     ZX48_ROM     : pmem=NIL;

     TRDOSROM     : pmem=NIL;
     SP_SCREEN    : pmem=NIL;

     ZX128_ROM    : array[0..1] of pmem=(NIL,NIL);
     PLUS2_ROM    : array[0..1] of pmem=(NIL,NIL);
     PLUS3_ROM    : array[0..3] of pmem=(NIL,NIL,NIL,NIL);

     PENTAGON_ROM : array[0..1] of pmem=(NIL,NIL);
     SCORPION_ROM : array[0..3] of pmem=(NIL,NIL,NIL,NIL);

procedure open_romTRDOS;
var f: file;
begin
 Displaynew('Loading TRDOS-ROM...');
 assign(f,'trdos.rom');reset(f,1);
 blockread(f,TrdosRom^,16384);
 close(f);
end;

procedure open_romPENTAGON;
var f:file;
begin
 Displaynew('Loading PENTAGON-ROM...');
 assign(f,'pentagon.rom');reset(f,1);
 blockread(f,pentagon_ROM[0]^,16384);
 blockread(f,pentagon_ROM[1]^,16384);
 close(f);
 PENTAGON_ROM[1]^[1386]:=237; {Probleme mit dem Tape-Loader}
 PENTAGON_ROM[1]^[1387]:=255;

end;

procedure open_romSCORPION;
var f:file;
begin
 Displaynew('Loading SCORPION-ROM...');
 assign(f,'scorpion.rom');reset(f,1);
 blockread(f,scorpion_ROM[0]^,16384);
 blockread(f,scorpion_ROM[1]^,16384);

 SCORPION_ROM[1]^[1386]:=237; {Probleme mit dem Tape-Loader}
 SCORPION_ROM[1]^[1387]:=255;
 close(f);
end;

procedure open_rom48k;
var f: file;
begin
 Displaynew('Loading 48k-ROM...');
 assign(f,'48.rom');reset(f,1);
 blockread(f,ZX48_ROM^,16384);
 close(f);
 ZX48_ROM^[1386]:=237;
 ZX48_ROM^[1387]:=255;
end;

procedure open_rom128k;
var f: file;
begin
 Displaynew('Loading 128k-ROM...');
 assign(f,'128.rom');reset(f,1);
 blockread(f,ZX128_ROM[0]^,16384);
 blockread(f,ZX128_ROM[1]^,16384);
 close(f);
 ZX128_ROM[1]^[1386]:=237;
 ZX128_ROM[1]^[1387]:=255;
end;

procedure open_romplus2;
var f: file;
begin
 Displaynew('Loading Plus2-ROM...');
 assign(f,'plus2.rom');reset(f,1);
 blockread(f,PLUS2_ROM[0]^,16384);
 blockread(f,PLUS2_ROM[1]^,16384);
 close(f);
 PLUS2_ROM[1]^[1386]:=237;
 PLUS2_ROM[1]^[1387]:=255;
end;

procedure open_romplus3;
var f: file;
begin
 Displaynew('Loading Plus3-ROM...');
 assign(f,'plus3.rom');reset(f,1);
 blockread(f,PLUS3_ROM[0]^,16384);
 blockread(f,PLUS3_ROM[1]^,16384);
 close(f);
 PLUS3_ROM[1]^[1386]:=237;
 PLUS3_ROM[1]^[1387]:=255;
end;


procedure initmem;
var x: byte;
    s:String;
begin
	for x:=0 to 7 do MemAlloc(ram[x],'RAM ',x);

	SRAM[1]:=RAM[5];
	SRAM[2]:=RAM[2];
	SRAM[3]:=RAM[0];

	SP_SCREEN:=RAM[5];

        halt_Error:='cannot allocate memory for temporary buffer';
        getmem(buffer,sizeof(tmemory));

        CONTENDED[0]:=0;CONTENDED[1]:=0;
        CONTENDED[2]:=1;CONTENDED[3]:=1;
        CONTENDED[4]:=0;CONTENDED[5]:=0;
        CONTENDED[6]:=0;CONTENDED[7]:=0;

end;

procedure closemem;
var x: byte;
begin
 for x:=0 to 7 do allocfree(ram[x]);
 freemem(buffer,sizeof(tmemory));
end;
